#include "ndelay.h"
#include <stm32f10x.h>

//     .
uint32_t UCALIBR=0;

//   n  .
void ndelay(uint32_t n)
{
    //    SysTick.
    uint32_t n0=SysTick->VAL;

    //   .
    uint32_t np=n0;

    // .
    if(n>UCALIBR)
        n-=UCALIBR;
    else
        return;

    //    SysTick.
    int32_t nc;

    //     ,   
    //    .
    do{
        nc=SysTick->VAL;

        //   , 
        //      .
        if(nc>=np)
            n0+=SysTick->LOAD+1;
        np=nc;
    }while(n0-nc<n);
}

//   .
// ,       .
void ncalibr()
{
    //    SysTick->LOAD.
    uint32_t load=SysTick->LOAD;
    //    
    //     .
    SysTick->LOAD=0x00FFFFFF;
    //     
    //     .
    SysTick->VAL=0;

    //    .
    bool primask=__get_PRIMASK();
    //  .
    __disable_irq();

    //    ndelay.
    const uint32_t SOME_TICKS=500;
    uint32_t n0=SysTick->VAL;
    ndelay(SOME_TICKS);
    UCALIBR=n0-SysTick->VAL-SOME_TICKS;

    /*
       //      
       //  , ,  .
       n0=SysTick->VAL;
       ndelay(100);
       uint32_t tmp1=n0-SysTick->VAL;

       n0=SysTick->VAL;
       ndelay(1000);
       uint32_t tmp2=n0-SysTick->VAL;

       //      
       //     tmp1, tmp2, ...
       //       
       //  ndelay   .
    */

    //   
    //     .
    SysTick->LOAD=load;
    SysTick->VAL=0;
    //   
    //   .
    __set_PRIMASK(primask);
}
